.model small
.stack 100h
.data
    msg1        DB "Iveskite simboliu eilute", 13, 10, "$"
    msg2        DB "Pabaiga", "$" 
    msg3        DB "Eiluteje buvo tiek simboliu:   ", "$"
    buferis        DB 255
    ilgis        DB "$"
    eilute        DB 255 dup (?)
    nauja_eil    DB 13, 10, "$"
    help        DB "Asemblerio uzduotis Nr 30", 13, 10, "Parasykite programa, kuri ", 13, 10, "ivesta simboliu eilute suskaido zodziais ir atspausdina eilutes ilgi", 13, 10, "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~", 13, 10, "Vykintas Vakys, PS, I kursas, IV grupe", 13, 10, "$"
    skaiciuok   DW 0
    isv         DW ? 
    daliklis    DB 10d
 
.code
start:
    mov AX, @data
    mov DS, AX
 
    mov BX, 81h         ;
                        ;
ciklas:    
    mov AX, ES:[BX]     ;skaitomas ES segmentas nuo BX baito   AX = s a (AH AL)
                        ;
    cmp AL, 0Dh         ;iri ar al nra enter
    je neradom            ;jei nra papildom parametr oka  neradom
 
    cmp AX, "?/"        ;jei nebuvo enter ziuri, ar parametras nera lygus /?
    je radom            ;radom /? ir nusoka i radom
 
    inc BX              ;jei nei enter, nei /? neranda, padidina BX 
    jmp ciklas          ;jei nerado nei enter nei /? kartoja cikla is naujo.
                        ;BX padidinamas tam, kad toliau skaitytu nuo kito baito. kokia bebt eilut, ji arba turs pabaig, arba turs /?,
                        ;arba bus per ilga, ko pasekoje tursite error.
 
radom:                  ;jei jau radom /? tai darom sitaip:
    mov AH, 09h         ;standartin teksto ivedimo funkcija [copy - paste]. AH pusbaiiui priskiriame reikm 9.
    mov DX, offset help ;spausdina help inut, kuri aprame data segmente.
    int 21h             ;ikvieiamas interuptas
    jmp pabaiga         ;okama  pabaig, kur programa udaroma.
 
neradom:                ;jei neranda parametr /?, daro itaip:
 
    mov AH, 09h            ;vlgi - eilutes isvedimas
    mov DX, offset msg1    ;priskiria inuts, kuri spausdina, adresa
    int 21h                ;21 interuptas (dosa)
 
 
skaitymas:
    mov AH, 0ah         ;standartin eiluts nuskaitymo funkcija
    mov DX, offset buferis    ;galima taip: lea DX, buferis
    int 21h
 
    xor CX, CX            ;unulina CX (griezta disjukcija)
    mov CL, [ilgis]     ; CL kelia eiluts ilgio reikm
    cmp CL, 0           ;
    je pabaiga          ;jei eilut lygi nuliui, tada oka  programos udarym
    mov SI, offset eilute  ;jei yra simboli, j rao  SI regstr  
 
    mov AH, 09h         ;ia dl elementaraus vaizdingumo - enter
    mov DX, offset nauja_eil
    int 21h
 
    mov BX, 00d         ;priskiriu nulio reikm BX. iuo atveju j naudoj kaip boolean'. ir ia jo reikm k
 
 
ciklas2:                ;prasideda viklas, kuris tikrins ar nra tarp
    lodsb                ;i funkcija priskiria AL paieliui po vien eiluts simbol
                        ;kitaip galima aprayti itaip:
                        ;mov AL, [SI]
                        ;inc SI
    inc skaiciuok       ;ia skaiiuojame, kiek simboli yra eilutje.
 
    cmp AL, 20h         ;tikrinam, ar AL priskirtas simbolis nra tarpas
    je keitimas           ;jei tarpas, okam  'tarpas'
    jmp spausdinimas1   ;jei ne tarpas - spausdinam simbol
 
spausdinimas1:          ;simbolio spausdinimas
    mov BX, 01d         ;priskiria reikm t.
 
    mov AH, 02h         ;taip apraome, jei spausdiname pavien simbol
    mov DX, [SI-1]        ;priskiriam DX tai, k spausdinsim
    int 21h             ;tradicikai ikvieiam interupt
 
    jmp kartojimas
 
keitimas:               ;keiiam tarp nauja eilute
    cmp BX, 00d         ;tikrinam ar kintamasis neturi reikms k. jei turi, vadinasi prie tai buvo spausdinta nauja eilut 
    je kartojimas       ;todl grtam atgal  cikl
 
    mov AH, 09h         ;jei BX turi reikm T[1], tai spausdiname nauj eilut.
    mov DX, offset nauja_eil
    int 21h
 
    mov BX, 00d         ;priskiriame BX reikm K[0], kad vietoj alia esanio tarpo nespausdint naujos eiluts vl
 
    jmp kartojimas      ;vl kartojam cikl
 
kartojimas:
    loop ciklas2        ;liepiam kartoti cikl. loop i esamos  reikms atima 1 ir nujumpina  nurodyt viet
 
nulinimas:                ;nunulinam CX registr
    xor CX, CX               
    mov AX, [skaiciuok] ;priskiriam AX simboli skaii
    jmp vertimas        ;dabar it skaii perversim  deimtain sistem.
 
vertimas:               ;keiiam  (12d=ch c/10 = 1 ir 2 liekana. 1/10 = 0 ir 1 liekana. suraom liekanas atvirkia tvarka - 12]
    div daliklis        ;dalinam AX i deimties. liekana keliauja  AH, sveikoji dalis  AL
    xor BX, BX          ;nunulinam BX, kur anksiau naudojome
    add AH, 30h         ;prie liekanos skaiio pridedame 30 [pastebime, kad 0, 1, 2... atitinkamai ascii lentelj lygs 30h, 31h, 32h...]
    mov BL, AH          ;priskiriame BL liekan
    push BX             ;ir j keliame  stack
    xor AH, AH          ;itrinam liekan
    inc CX              ;padidiname CX vienetu - skaiiuojam, kiek skaiius turi skaitmen
    cmp AL, 0           ;palyginam, ar sveikoji dali lygi nuliui
    ja vertimas         ;jei nelygi kartojam cikl, dalinam j inaujo ir t.t.
 
    mov AH, 09h         ;jei lygi nuliui, vadinasi skaiius jau sutvarkytas. stacke sudlioti tvarkingai skaiiai
    mov DX, offset nauja_eil ;kad tvarkingai atrodyt - praleidiam eilut
    int 21h
 
    mov AH, 09h         ;paraome inut, kad yra tiek simboli:
    mov DX, offset msg3
    int 21h
 
    jmp spausdinimas2   ;ir spausdinam simboli skaii
 
spausdinimas2:          ;simboli skaiiaus spausdinimas:
    pop isv             ;i stacko iimam virutin skaitmen ir j priskiriam isv wordui
    mov AH, 02h         ;spausdinam t skaitmen
    mov DX, [isv]
    int 21h
 
    loop spausdinimas2  ;i CX atimamas vienetas ir spausdinamas kitas skaitmuo
 
    mov AH, 09h         ;kai CX gyj reikm 0, visi skaitmenys atspausdinti, persikeliam   nauj eilut
    mov DX, offset nauja_eil
    int 21h  
 
    jmp pabaiga         ;ir udarinjam program
 
pabaiga:     
    mov AH, 09h         ;dl tvarkos padarom tarp
    mov DX, offset nauja_eil
    int 21h 
 
    mov AH, 09h         ;atspausdiname od pabaiga, kad niekam nekilt noras tvirkinti programos toliau
    mov DX, offset msg2
    int 21h
 
    mov Ax, 4c00h       ;ir [copy-paste] udarome program
    int 21h     
 
end start